# TheDuke

[![Build Status](https://travis-ci.com/ArcGIS/TheDuke.svg?token=eqLvn6ALxqzVL1xMAjuq&branch=master)](https://travis-ci.com/ArcGIS/TheDuke)
[![JavaScript Style Guide](https://img.shields.io/badge/code_style-standard-brightgreen.svg)](https://standardjs.com)

Job code utility library for ArcGIS Hub

Composer + Jazz + Washington, D.C. = [The Duke](https://en.wikipedia.org/wiki/Duke_Ellington)

# Prerequisites
You will need the following things installed on your computer.

- [Git](https://git-scm.com/)
- [Node.js](https://nodejs.org)
- [NVM](https://github.com/creationix/nvm)

# Installation

- get the repo on your computer:
  - `git clone git@github.com:ArcGIS/TheDuke.git` or
  - `git clone https://github.com/ArcGIS/TheDuke.git`
- install dependencies: `npm install`

# Running / Development

- `nvm use`
- `npm run watch`
- edit files in /src or /test directories
- verify that node-watch runs the linter, tests, and build scripts
- :hammer:

# Harvesting

- Group layers are not turned into datasets of any kind. Hence they are filtered out during compose step.

# Compose Structure

Refer to

- [Compose scenarios](https://gist.github.com/pranavkulkarni/51de24753f3a30c03d0144ba89e51d7e)

```
{
  errors:[
    {
      ...
    }
  ]
  item:
  metadata:
  groups:
  server: <only if item has a feature|map|image server>
  layers: <only if item has a feature|map server>
  default: <top level keys like createdAt, name, title, tags, source etc.>
}
```

# Error Structure
```
{
  message:
  stack:
  name: <examples: FetchError | TypeError | SomeCustomError etc. >
  timestamp:
  field: <The field that caused this error like item | metadata | groups etc. >
  url: <may be null if not HTTPError>
  statusCode: <may be null if not HTTPError>
  httpMethod: <may be null if not HTTPError else 'get', 'post' etc.>
}
```
